import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * A symbol for a matrix effect.
 * 
 * @author Jamie Vaughan aka Spilli (original idea) http://www.greenfoot.org/scenarios/1552
 * @author Ed Parrish 
 * @version 1.0  5/09/2014
 */
public class Symbol extends Actor
{
    private static final Color color = new Color(0, 255, 0, 196);
    private static final Color TRANSPARENT = new Color(0, 0, 0, 0);
    private static final int DELAY = 2;

    private int alpha = 0;
    private String letter;
    private int counter;
    private boolean leader;

    public Symbol(String letter, boolean isLeader)
    {
        this.letter = letter;
        leader = isLeader;
        GreenfootImage img = new GreenfootImage(letter, 20, color, TRANSPARENT);
        if (!leader) img.setTransparency(alpha);
        setImage(img);
    }

    /**
     * Act - do whatever the Symbol wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        fall();
        draw();
    }

    public void fall()
    {
        counter++;
        if (counter > DELAY)
        {
            if(getY() >= getWorld().getHeight()) {
                getWorld().removeObject(this);
            } else {
                setLocation(getX(), getY() + 1);
                counter = 0;
                if (leader) {
                    getWorld().addObject(new Symbol(letter, false), getX(), 0);
                }
            }
        }

    }

    public void draw()
    {
        if (!leader)
        {
            GreenfootImage img = getImage();
            if (alpha < 196)
            {
                alpha += 2;
                img.setTransparency(alpha);
            }
        }
    }
}
